<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id: form_fields.inc.php 200 2007-07-04 12:34:56Z balu $ */

// pre_modded for mod_text by M. Rsel www.conpresso4.de

if (!defined('CPO')) exit;

if (!nametype($key, $name, $type)) continue;

// If this placeholder is marked to not be queried, skip it
if (isset($value['noquery']) && (bool)($value['noquery'])) return;

// {{{ mod_text
if (array_key_exists('mod_text',$activeModules)) include(CPO_BASEDIR.$activeModules['mod_text']['directory'].'/includes/hiddencode.inc.php');
// }}}

if (!is_array($content)) $content = array();

switch ($type) {
case 'file': // {{{
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty values exist for a key without content.
    if (!array_key_exists($key, $content)) $content[$key] = array('id'=>'', 'file_id'=>'');

    printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
        htmlspecialchars($name));
    // print label
    if (isset($value['label']) && trim($value['label'])!='') {
        printf('%s<br /><br />', $value['label']);
    }

    // print file selection box
    $query = "SELECT id, beschreibung, datei "
            ."FROM ".CPO_DATA." "
            ."WHERE (rubric_id='".$_SESSION['SID_rubric_id']."' "
            ."OR rubric_id='-1' ) "
            ."AND format='1' "
			.((isset($value['relation']) && isset($value['pattern']) && trim($value['relation'])!='') ? "AND datei LIKE '".str_replace('###',$content[trim($value['relation']).' (text)']['text'],$value['pattern'])."' " : '') // file_filter
            ."ORDER BY datei";
    DEBUG(1, 'Fetching files for this rubric.<br /><br />'.$query, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query); 

    printf('<select name="content[%s][file_id]" size="1" class="inputwidth iframe">', 
        htmlspecialchars($key));
    print('<option value="">'.___('no file').'</option>');
    print('<option value="">------</option>');

    while($db_2->next_record()) {
        $id             = $db_2->v('id');
        $k_datei        = $db_2->v('datei');
        $k_beschreibung = '['.substr($db_2->v('beschreibung'), 0, 77-strlen($k_datei)).']';
        if ($k_beschreibung=='[]') $k_beschreibung = '';

        $_selected = '';
        if ($content[$key]['file_id']==$id) $_selected = 'selected';

        printf('<option value="%s" %s>%s) %s %s</option>',
            $id,
            $_selected,
            str_repeat('0', 3-strlen($id)).$id,
            $k_datei,
            $k_beschreibung
        );
    }
    print('</select>');
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-files'));
    print('</td></tr>');
    break; // }}}
case 'image': // {{{
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty values exist for a key without content.
    if (!array_key_exists($key, $content)) {
        $content[$key] = array('id'=>'', 'image_id'=>'');
    }

    printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
        $name);
    if (isset($value['label']) && trim($value['label'])!='') {
        printf('%s<br /><br />', $value['label']);
    }

    $query = "SELECT id, beschreibung, datei FROM ".CPO_DATA." "
            ."WHERE (rubric_id='".$_SESSION['SID_rubric_id']."' "
            ."OR rubric_id='-1') " 
            ."AND format='2' "
			.((isset($value['relation']) && isset($value['pattern']) && trim($value['relation'])!='') ? "AND datei LIKE '".str_replace('###',$content[trim($value['relation']).' (text)']['text'],$value['pattern'])."' " : '') // file_filter
            ."ORDER BY datei"; 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query); 

    printf('<select name="content[%s][image_id]" size="1" class="inputwidth">', htmlspecialchars($key));
    print('<option value="">'.___('no image').'</option><option value="">------</option>');
    while($db_2->next_record()):
        $k_beschreibung = '['.substr($db_2->v('beschreibung'), 0, 76-strlen($db_2->v('datei'))).']';
        if ($k_beschreibung=='[]') $k_beschreibung = '';

        $_selected = '';
        if ($content[$key]['image_id']==$db_2->v('id')) {
            $_selected = 'selected';
        }

        printf('<option value="%s" %s>%s) %s %s</option>',
            $db_2->v('id'),
            $_selected,
            str_repeat('0', 4-strlen($db_2->v('id'))).$db_2->v('id'),
            $db_2->v('datei'),
            $k_beschreibung
        );
    endwhile;
    print('</select>');
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-images'));
    print('</td></tr>');
    break; // }}}
case 'text': // {{{
	// {{{ mod_text
	if ($value['formtype']=='short') $value['inputmethod'] = 'text';
	if (array_key_exists('mod_text',$activeModules)) { include(CPO_BASEDIR.$activeModules['mod_text']['directory'].'/includes/form_fields.inc.php'); break; } 
	// }}}
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty values exist for a key without content.
    if (!array_key_exists($key, $content)) {
        $content[$key] = array('id'=>'', 'text'=>'');
    }

    printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
        htmlspecialchars($name));
    if (isset($value['label']) && trim($value['label'])!='') {
        printf('%s<br /><br />', $value['label']);
    }

    if (isset($value['short'])) {
        printf('<input type="text" name="content[%s][text]" value="%s" size="80" class="inputwidth">', 
            htmlspecialchars($key),
            htmlspecialchars($content[$key]['text'])
        );
        print(help('articles-createarticle.html#articles-createarticle-articlecontent-texts-shorttext'));
        print('</td></tr>');
        break;
    } 

    printf('<textarea name="content[%s][text]" cols="80" rows="15" class="inputwidth">%s</textarea>', 
        htmlspecialchars($key),
        htmlspecialchars($content[$key]['text'])
    );
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-texts-text'));
    print('</td></tr>');
    break; // }}}
case 'html': // {{{
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty value exist for a key without content.
    if (!array_key_exists($key, $content)) { 
        $content[$key] = array('id'=>'', 'html'=>'');
    }

    printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
        htmlspecialchars($name));
    if (isset($value['label']) && trim($value['label'])!='') {
        printf('%s<br /><br />', $value['label']);
    }

    if (!RTECheck()) {
        printf('<textarea name="content[%s][html]" cols="80" rows="15" class="inputwidth">%s</textarea>', 
            htmlspecialchars($key),
            htmlspecialchars($content[$key]['html'])
        );
        echo help(''); // helpme
        echo '<br />';
        printf(___('Please note that your browser (%s) is not capable of rich-text-editing, so you can only edit the HTML-Code in the textarea above.'),
            '<em>'.htmlspecialchars($_SERVER['HTTP_USER_AGENT']).'</em>'
        );
        print('</td></tr>');
        break;
    } 
    $md5key = md5($key);     // create an easy to use key for the iframe
    $html_texts[] = $md5key; // this allows to add a javascript which puts all iframes into the hidden field later

    printf('<iframe id="iframe_%1$s" name="%1$s" frameborder="0" height="200" class="iframe inputwidth"></iframe>',
        $md5key
    );
    printf('<input type="hidden" name="content[%s][html]" id="feld_%s" value="">', 
        htmlspecialchars($key), 
        $md5key
    );
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-texts-html'));

    $text_value = $content[$key]['html'];
    // to avoid problems with the document.writeln below
    $text_value = preg_replace ('/(\015\012|\015|\012)/', ' ', $text_value); 
    $text_value = preg_replace ("/'/", "\\'", $text_value); 
    $text_value = str_replace('</', '<\/', $text_value);
    ?>
    <script type="text/javascript">
        iframe = document.getElementById('iframe_<?php echo $md5key; ?>').contentWindow;
        iframe.document.clear();
        iframe.document.open();
        iframe.document.writeln('<?php echo $text_value; ?>');
        iframe.document.close();
    </script>

    <?php
        printf('<br /><A HREF="#text_%1$s" onClick="editorwindow = window.open(\''.BASE_REL.'_editor/editor.php?saveto=iframe_%1$s&%2s\', \'editor_popup\', \'dependent=yes, width=750, height=580, resizable=yes, status=yes\');">'
          .'<img src="'.SKIN_URL.'edit.gif" width="20" height="18" align="absmiddle" alt="%3$s" >%3$s'
          .'</A>',
        $md5key,
        SID,
        ___('-edit')
    );
    print('</td></tr>');
    break; // }}}
case 'url': // {{{
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty value exist for a key without content.
    if (!array_key_exists($key, $content)) {
        $content[$key] = array('id'=>'', 'url'=>'', 'urltext'=>'', 'urltarget'=>'');
    }

    printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
        htmlspecialchars($name));
    if (isset($value['label']) && trim($value['label'])!='') printf('%s<br />', $value['label']);

    if ($value['linktype']!=0) {
        printf('<input type="hidden" name="content[%s][url]" value="">', 
            htmlspecialchars($key)
        );
    } else {
        printf('</td></tr><tr '.$markashidden.' class="same"><td class="leftrow">%s</td><td class="rightrow">', ___('URL:'));
        printf('<input type="text" name="content[%s][url]" value="%s" id="%s" class="inputwidth">', 
            htmlspecialchars($key),
            htmlspecialchars($content[$key]['url']),
            htmlspecialchars(md5($key))
        );
        print(help('articles-createarticle.html#articles-createarticle-articlecontent-url-url'));

        echo '<br />';
        echo ' <select class="inputwidth" id="edit_a_rubric" onChange="getElementById(\''.htmlspecialchars(md5($key)).'\').value = this.value; this.selectedIndex=0;">';
        echo '<option value="">'.__('Generate a link to a rubric:').'</option>';
        $db = new DB;
        $query = "SELECT id, name, directory "
                ."FROM ".CPO_RUBRIC." "
                .'ORDER BY name';
        $db->query($query);
        while($db->next_record()) {
            printf('<option value="%s">%s</option>',
                htmlspecialchars(BASE_ABS.$db->v('directory').'/index.php?rubric='.urlencode($db->v('name'))),
                htmlspecialchars($db->v('name'))
            );
        }
        echo '</select>';

    }


    printf('</td></tr><tr '.$markashidden.' class="same"><td class="leftrow">%s</td><td class="rightrow">', ___('Link text:'));
    printf('<input type="text" name="content[%s][urltext]" value="%s" class="inputwidth">', 
        htmlspecialchars($key),
        htmlspecialchars($content[$key]['urltext'])
    );
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-url-linktext'));

    printf('</td></tr><tr '.$markashidden.' class="same"><td class="leftrow">%s</td><td class="rightrow">', ___('Target:'));
    $targets = explode(' ', $cpoSystem['targets']);
    printf('<select name="content[%s][urltarget]" size="1" class="inputwidth">', htmlspecialchars($key));
    print('<option value="">No target</option><option value="">------</option>');
    foreach($targets as $v) {
        printf('<option value="%1$s" %2$s>%1$s</option>',
            htmlspecialchars($v),
            trim($content[$key]['urltarget'])==trim($v) ? 'selected' : ''
        );
    }
    print('</select>');
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-url-target'));
    print('</td></tr>');
    break; // }}}
case 'value': // {{{
    break; // }}}
default: // {{{
    printf('<!-- Not defined typeTag %s (%s)-->', htmlspecialchars($type), htmlspecialchars($name));
    break; // }}}
}
print($divider);
?>
