<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */

// pre_modded for mod_text by M. Rsel www.conpresso4.de

define('CPO', true);
require_once('../_include/checkaccess.inc.php');

$views = array('list'); // set default view

$actions = array('list');
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);
else unset($_SESSION['SID_placeholders_select_id']);

while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'list': // {{{
        $template_id = $_REQUEST['template'];
        $dbq = new DB;
        $dbq->query(
            'SELECT name FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$template_id
        );
        $dbq->next_record();
        $templatename = $dbq->v('name');

        $views = array('list');
        break; // }}}
    case 'bottom': // {{{
        $q = "SELECT id, pos, templates_id FROM ".CPO_PLACEHOLDERS." "
            ."WHERE id=".(int)$_GET['id'];
        $dbq = new DB;
        $dbq->query($q);
        $dbq->next_record();
        $id          = $dbq->v('id');
        $pos         = $dbq->v('pos');
        $template_id = $dbq->v('templates_id');

        $q = 'UPDATE '.CPO_PLACEHOLDERS.' '
            .'SET pos=pos-1 '
            .'WHERE templates_id='.(int)$template_id." "
            .'AND pos>'.((int)$pos);
        $dbq->query($q);

        $q = 'UPDATE ' . CPO_PLACEHOLDERS . ' AS t1, ' .
             '(SELECT MAX(pos) AS maxPos FROM ' . CPO_PLACEHOLDERS .
                 ' WHERE templates_id=' . (int)$template_id . ') AS t2 ' .
             'SET t1.pos = t2.maxPos+1 WHERE t1.id = ' . (int)$id;
        $dbq->query($q);

        $dbq->query(
            'SELECT name FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$template_id
        );
        $dbq->next_record();
        $templatename = $dbq->v('name');
        
        $pholderpos = -1;
        $views = array('list');
        break; // }}}
    case 'down': // {{{
        $q = "SELECT id, pos, templates_id FROM ".CPO_PLACEHOLDERS." "
            ."WHERE id=".(int)$_GET['id'];
        $dbq = new DB;
        $dbq->query($q);
        $dbq->next_record();
        $id          = $dbq->v('id');
        $pos         = $dbq->v('pos');
        $template_id = $dbq->v('templates_id');

        // move next entry one down
        $q = 'UPDATE '.CPO_PLACEHOLDERS.' '
            .'SET pos=pos-1 '
            .'WHERE templates_id='.(int)$template_id." "
            .'AND pos='.((int)$pos+1);
        $dbq->query($q);

        // move this entry one up
        $q = 'UPDATE '.CPO_PLACEHOLDERS.' '
            .'SET pos=pos+1 '
            .'WHERE id='.(int)$id;
        $dbq->query($q);

        $dbq->query(
            'SELECT name FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$template_id
        );
        $dbq->next_record();
        $templatename = $dbq->v('name');
        
        $pholderpos = $pos+1;
        $views = array('list');
        break; // }}}
    case 'placeholders_pastebefore': // {{{
        $q = 'SELECT id, pos, templates_id FROM ' . CPO_PLACEHOLDERS . ' ' .
             'WHERE id=' . (int)$_GET['id'] . ' ' .
             'OR    id=' . (int)$_SESSION['SID_placeholders_select_id'];
        $dbq = new DB;
        $dbq->query($q);
        while ($dbq->next_record()) {
            if ($dbq->v('id')==(int)$_SESSION['SID_placeholders_select_id'])
                $posSelected = $dbq->v('pos');
            else
                $posBefore    = $dbq->v('pos');
            $template_id = $dbq->v('templates_id');
        }

        if ($posSelected<$posBefore) {
            $q = 'UPDATE ' . CPO_PLACEHOLDERS . ' ' .
                 'SET pos=pos-1 ' .
                 'WHERE pos>' . $posSelected . ' ' .
                 'AND pos<'. $posBefore . ' ' .
                 'AND templates_id=' . (int)$template_id;
            $dbq->query($q);

            $q = 'UPDATE ' . CPO_PLACEHOLDERS . ' ' .
                 'SET pos= ' . ($posBefore-1) . ' ' .
                 'WHERE id=' . (int)$_SESSION['SID_placeholders_select_id'];
            $dbq->query($q);
        } else {
            $q = 'UPDATE ' . CPO_PLACEHOLDERS . ' ' .
                 'SET pos=pos+1 ' .
                 'WHERE pos>=' . $posBefore . ' ' .
                 'AND pos<'. $posSelected . ' ' .
                 'AND templates_id=' . (int)$template_id;
            $dbq->query($q);

            $q = 'UPDATE ' . CPO_PLACEHOLDERS . ' ' .
                 'SET pos= ' . ($posBefore) . ' ' .
                 'WHERE id=' . (int)$_SESSION['SID_placeholders_select_id'];
            $dbq->query($q);
        }

        $views = array('list');
        unset($_SESSION['SID_placeholders_select_id']);
        break; // }}}
    case 'placeholders_pasteafter': // {{{
        $q = 'SELECT id, pos, templates_id FROM ' . CPO_PLACEHOLDERS . ' ' .
             'WHERE id=' . (int)$_GET['id'] . ' ' .
             'OR    id=' . (int)$_SESSION['SID_placeholders_select_id'];
        $dbq = new DB;
        $dbq->query($q);
        while ($dbq->next_record()) {
            if ($dbq->v('id')==(int)$_SESSION['SID_placeholders_select_id'])
                $posSelected = $dbq->v('pos');
            else
                $posAfter    = $dbq->v('pos');
            $template_id = $dbq->v('templates_id');
        }

        if ($posSelected<$posAfter) {
            $q = 'UPDATE ' . CPO_PLACEHOLDERS . ' ' .
                 'SET pos=pos-1 ' .
                 'WHERE pos>' . $posSelected . ' ' .
                 'AND pos<='. $posAfter . ' ' .
                 'AND templates_id=' . (int)$template_id;
            $dbq->query($q);

            $q = 'UPDATE ' . CPO_PLACEHOLDERS . ' ' .
                 'SET pos= ' . $posAfter . ' ' .
                 'WHERE id=' . (int)$_SESSION['SID_placeholders_select_id'];
            $dbq->query($q);
        } else {
            $q = 'UPDATE ' . CPO_PLACEHOLDERS . ' ' .
                 'SET pos=pos+1 ' .
                 'WHERE pos>' . $posAfter . ' ' .
                 'AND pos<'. $posSelected . ' ' .
                 'AND templates_id=' . (int)$template_id;
            $dbq->query($q);

            $q = 'UPDATE ' . CPO_PLACEHOLDERS . ' ' .
                 'SET pos= ' . ($posAfter+1) . ' ' .
                 'WHERE id=' . (int)$_SESSION['SID_placeholders_select_id'];
            $dbq->query($q);
        }

        $views = array('list');
        unset($_SESSION['SID_placeholders_select_id']);
        break; // }}}
    case 'up': // {{{
        $q = 'SELECT id, pos, templates_id FROM '.CPO_PLACEHOLDERS.' '
            .'WHERE id='.(int)$_GET['id'];
        $dbq = new DB;
        $dbq->query($q);
        $dbq->next_record();
        $id          = $dbq->v('id');
        $pos         = $dbq->v('pos');
        $template_id = $dbq->v('templates_id');

        // move next entry one up
        $q = 'UPDATE '.CPO_PLACEHOLDERS.' '
            .'SET pos=pos+1 '
            .'WHERE templates_id='.(int)$template_id." "
            .'AND pos='.((int)$pos-1);
        $dbq->query($q);

        // move this entry one up
        $q = 'UPDATE '.CPO_PLACEHOLDERS.' '
            .'SET pos=pos-1 '
            .'WHERE id='.(int)$id;
        $dbq->query($q);
        
        $dbq->query(
            'SELECT name FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$template_id
        );
        $dbq->next_record();
        $templatename = $dbq->v('name');
        
        $pholderpos = $pos-1;
        $views = array('list');
        break; // }}}
    case 'top': // {{{
        $q = 'SELECT id, pos, templates_id FROM '.CPO_PLACEHOLDERS.' '
            .'WHERE id='.(int)$_GET['id'];
        $dbq = new DB;
        $dbq->query($q);
        $dbq->next_record();
        $id          = $dbq->v('id');
        $pos         = $dbq->v('pos');
        $template_id = $dbq->v('templates_id');

        // move next entry one up
        $q = 'UPDATE '.CPO_PLACEHOLDERS.' '
            .'SET pos=pos+1 '
            .'WHERE templates_id='.(int)$template_id." "
            .'AND pos<'.((int)$pos);
        $dbq->query($q);

        // move this entry one up
        $q = 'UPDATE '.CPO_PLACEHOLDERS.' '
            .'SET pos=1 '
            .'WHERE id='.(int)$id;
        $dbq->query($q);
        
        $dbq->query(
            'SELECT name FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$template_id
        );
        $dbq->next_record();
        $templatename = $dbq->v('name');
        
        $pholderpos = -1;
        $views = array('list');
        break; // }}}
    case 'edit': // {{{
        // fetch placeholder to list its settings
        $q = 'SELECT id, templates_id, ttype, fieldname, pos, ddata FROM '.CPO_PLACEHOLDERS.' '
            .'WHERE id='.(int)$_GET['id'];
        $dbq = new DB;
        $dbq->query($q);
        $dbq->next_record();
        $placeholder = unserialize($dbq->v('ddata'));
        if (!is_array($placeholder)) $placeholder = array();
        $placeholder['name']  = $dbq->v('fieldname');
        $placeholder['type']  = $typeNames[$dbq->v('ttype')];
        $placeholder['pos']   = $dbq->v('pos');
        $placeholder['id']    = $dbq->v('id');
        $placeholder['templates_id'] = $dbq->v('templates_id');
        
        $views = array('edit');
        break; // }}}
    case 'create': // {{{
        $db = new DB;
        $db->query(
            'SELECT name FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$_REQUEST['templates_id']
        );
        $db->next_record();
        $templatename = $db->v('name');

        $views = array('create');
        break; // }}}
    case 'createsave': // {{{
        $template_id = $_POST['templates_id'];

        $dbq = new DB;

        $q = 'SELECT count(*) FROM '.CPO_PLACEHOLDERS.' '
            ."WHERE fieldname='".addslashes($_POST['name'])."' "
            .'AND templates_id='.(int)$_POST['templates_id'];
        $dbq->query($q);
        $dbq->next_record();

        if ($dbq->v('count(*)')>0) {
            $message[] = ___('A placeholder with this name does already exist. Please choose a different name.');
            $views = array('create');
            break;
        }

        if (trim($_POST['name'])=='') {
            $message[] = ___('Please specify a name for this placeholder.');
            $views = array('create');
            break;
        }

        // make space for the new placeholder
        $q = 'UPDATE '.CPO_PLACEHOLDERS.' '
            .'SET pos=pos+1 '
            .'WHERE pos>='.(int)$_POST['pos'].' '
            .'AND templates_id='.(int)$_POST['templates_id'];
        $dbq->query($q);

        $q = 'INSERT INTO '.CPO_PLACEHOLDERS.' SET '
            .'templates_id='.(int)$_POST['templates_id'].', '
            .'ttype='.(int)$_POST['type'].', '
            ."fieldname='".addslashes($_POST['name'])."', "
            .'pos='.(int)$_POST['pos'];
        $dbq->query($q);

        $dbq->query('SELECT last_insert_id()');
        $dbq->next_record();
        $placeholder = array();
        $placeholder['id']    = $dbq->v('last_insert_id()');
        $placeholder['name']  = $_POST['name'];
        $placeholder['type']  = $typeNames[$_POST['type']];
        $placeholder['pos']   = $_POST['pos'];
        $placeholder['templates_id'] = $_POST['templates_id'];

        logaction('placeholders create', $placeholder['name'] . ' (' . $placeholder['id'] . ')');

        $views = array('edit');
        break; // }}}
    case 'save': // {{{
        $ddata = serialize($_POST['placeholder']);
        $q = 'UPDATE '.CPO_PLACEHOLDERS.' '
            ."SET ddata='".addslashes($ddata)."' "
            .'WHERE id='.(int)$_POST['id'];
        $dbq = new DB;
        $dbq->query($q);

        $q = 'SELECT templates_id, fieldname FROM '.CPO_PLACEHOLDERS.' '
            .'WHERE id='.(int)$_REQUEST['id'];
        $dbq->query($q);
        $dbq->next_record();
        $template_id = $dbq->v('templates_id');

        logaction('placeholders save', $dbq->v('fieldname') . ' (' . $_POST['id'] . ')');

        $message[] = sprintf(___('Placeholder %s was successfully saved.'),
                '<em>' . $dbq->v('fieldname') . '</em>');
        
        $dbq->query(
            'SELECT name FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$template_id
        );
        $dbq->next_record();
        $templatename = $dbq->v('name');

        $views = array('list');
        break; // }}}
    case 'delete': // {{{
        // FIXME add check if exists in template

        $dbq = new DB;
        $q = "SELECT fieldname, pos, templates_id FROM ".CPO_PLACEHOLDERS." "
            ."WHERE id=".(int)$_REQUEST['id'];
        $dbq->query($q);
        $dbq->next_record();

        $pos = $dbq->v('pos');
        $fieldname = $dbq->v('fieldname');
        $template_id = $dbq->v('templates_id');

        $views = array('reallydelete');
        break; // }}}
    case 'reallydelete': // {{{
        $views = array('list');

        $dbq = new DB;
        $q = "SELECT fieldname, pos, templates_id FROM ".CPO_PLACEHOLDERS." "
            ."WHERE id=".(int)$_REQUEST['id'];
        $dbq->query($q);
        $dbq->next_record();
        $pos = $dbq->v('pos');
        $fieldname = $dbq->v('fieldname');
        $template_id = $dbq->v('templates_id');

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The placeholder %s was not deleted.'),
                '<em>'.htmlspecialchars($fieldname).'</em>');
            break;
        }

        if ($_SESSION['SID_placeholders_select_id']==(int)$_REQUEST['id']) {
            unset($_SESSION['SID_placeholders_select_id']);
        }

        $q = 'DELETE FROM '.CPO_PLACEHOLDERS.' '
            .'WHERE id='.(int)$_REQUEST['id'];
        $dbq->query($q);

        $q = 'UPDATE '.CPO_PLACEHOLDERS.' SET '
            .'pos=pos-1 '
            .'WHERE pos>'.(int)$pos.' '
            .'AND templates_id='.(int)$template_id;
        $dbq->query($q);

        $dbq->query(
            'SELECT name FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$template_id
        );
        $dbq->next_record();
        $templatename = $dbq->v('name');
        
        $message[] = sprintf(___('The placeholder %s was deleted.'),
                        '<em>'.htmlspecialchars($fieldname).'</em>');
        logaction('placeholders delete', $fieldname . ' (' . $_REQUEST['id'] . ')');
        break; // }}}
    case 'placeholders_select':
        $_SESSION['SID_placeholders_select_id'] = $_GET['id'];
        
        $q = 'SELECT name, templates_id ' . 
             'FROM ' . CPO_PLACEHOLDERS . ', ' . CPO_TEMPLATES . ' ' .
             'WHERE ' . CPO_TEMPLATES . '.id=templates_id ' .
             'AND '. CPO_PLACEHOLDERS . '.id=' .(int)$_GET['id'];
        $dbq = new DB;
        $dbq->query($q);
        $dbq->next_record();
        $template_id  = $dbq->v('templates_id');
        $templatename = $dbq->v('name');

        $views = array('list');
        break;
    }
}

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'list': // {{{
        $db = new DB;
        $q = 'SELECT tpl_first, tpl_detail, tpl_javascript FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$template_id;
        $db->query($q); 
        $db->next_record();

        $template_datei_full = $db->v('tpl_first')."\n".$db->v('tpl_detail')."\n".$db->v('tpl_javascript');
        preg_match_all($tagsPreg, $template_datei_full, $matches, PREG_SET_ORDER);
        $phInTemplate = array();
        foreach ($matches as $match) {
            $_type = strtolower(trim($match[1]));
            $_name = preg_replace("/(\r\n|\n|\r)/", ' ', trim($match[2]));

            if ($_name=='')  continue;
            if ($_type=='value') continue;

            $pos = $_name.' ('.$_type.')';
            $phInTemplate[$pos] = true;
        }

        // fetch placeholders to list them
        $q = 'SELECT id, ttype, fieldname, pos, ddata FROM '.CPO_PLACEHOLDERS.' '
            .'WHERE templates_id='.(int)$template_id.' '
            .'ORDER BY pos';
        $dbq = new DB;
        $dbq->query($q);

        $placeholder = array();
        while($dbq->next_record()) {
            $phname = $dbq->v('fieldname').' ('.$typeNames[$dbq->v('ttype')].')';
            $placeholder[$phname] = unserialize($dbq->v('ddata'));
            $placeholder[$phname]['name']  = $dbq->v('fieldname');
            $placeholder[$phname]['type']  = $typeNames[$dbq->v('ttype')];
            $placeholder[$phname]['pos']   = $dbq->v('pos');
            $placeholder[$phname]['id']    = $dbq->v('id');
        }
        
        if (!empty($_SESSION['SID_placeholders_select_id'])) {
            $message[] = sprintf(__('Select mode active. You can move or %sundo%s the selection.'),
                '<a href="' . BASE_REL . '_admin/manage_placeholders.php?template=' . (int)$template_id . '">',
                '</a>'
            );
        }


        require(CPO_BASEDIR.'_include/header.php');
        printPageHeader(
            __('Work on placeholders'),
            sprintf(__('In this view you work on the order of the placeholders of the selected article-template %s and select a placeholder to work on its settings.'),
                '<em>'.htmlspecialchars($templatename).'</em>'),
            'templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder'
        );

        if (count($placeholder)==0) {
            $message[] =  __('No placeholders found.').' '
                .sprintf(___('You can %screate a new placeholder%s.'),
                    '<a href="'.BASE_REL.'_admin/manage_placeholders.php?action=create&amp;pos=1&amp;templates_id='.(int)$template_id.'">',
                    '</a>');
            include(CPO_BASEDIR.'_include/message.php');
            include(CPO_BASEDIR.'_include/footer.php');
            break;
        }

        include(CPO_BASEDIR.'_include/message.php');
        ?>

        <table class="ruler" style="width: 100%"><thead>
        <tr>
            <th style="width:  1%;"><span><?php echo help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-sorting'); ?></span></th>
            <th style="width: 39%;"><span><?php echo ___('Placeholder name').help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-placeholdername'); ?></span></th>
            <th style="width:  5%;"><span><?php echo ___('Manage').help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-edit'); ?></span></th>
            <th style="width: 10%;"><span><?php echo ___('Type').help(''); // helpme ?></span></th>
            <th style="width: 45%;"><span><?php echo ___('Description').help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-description'); ?></span></th>
        </tr>
        </thead><tbody>
        <?php
        foreach ($placeholder as $key=>$value) {
            if ($value['type']=='value') continue;
            if ($value['type']=='ifnotset' || $value['type']=='ifset') continue;

            if ($_SESSION['SID_placeholders_select_id']==$value['id']) {
                echo '<tr class="table_system_active">';
            } else {
                echo '<tr>';
            }

            printf('<td>');
                if ($value['pos']==1) {
                    print('<img src="'.SKIN_URL.'sort_empty'
                        .($pholderpos==$value['pos'] && $_GET['action']=='up' 
                            ? '2' 
                            : '').'.gif" style="width: 13px; height: 13px; margin-right: 2px;" alt="" >');
                    print('<img src="'.SKIN_URL.'sort_empty'
                        .($_GET['action']=='top'
                            ? '2'
                            : '').'.gif" style="width: 13px; height: 13px; margin-right: 2px;" alt="" >');
                } else {
                    printf('<a href="%s?id=%s&amp;action=up">',
                        htmlspecialchars($_SERVER['PHP_SELF']),
                        htmlspecialchars($value['id'])
                    );
                    print('<img src="'.SKIN_URL.'sort_up'.($pholderpos==$value['pos'] && $_GET['action']=='up'?'2':'').'.gif" style="width: 13px; height: 13px; margin-right: 2px;" alt="'.___('move up').'" title="'.___('move up').'" /></a>');
                    printf('<a href="%s?id=%s&amp;action=top">',
                        htmlspecialchars($_SERVER['PHP_SELF']),
                        htmlspecialchars($value['id'])
                    );
                    print('<img src="'.SKIN_URL.'sort_top.gif" style="width: 13px; height: 13px; margin-right: 2px;" alt="'.___('move to top').'" title="'.___('move to top').'" /></a>');

                }

                $mark = '';
                // paste before
//                $mark = ($_GET['mark']=='pb' . $value['id'] ? '2' : '');
                if (!empty($_SESSION['SID_placeholders_select_id'])) {
                    if ($value['id']!=$_SESSION['SID_placeholders_select_id']) {
                        echo '<a href="' . BASE_REL.'_admin/manage_placeholders.php?action=placeholders_pastebefore&id=' . $value['id'] . '&mark=pb' . $value['id'] . '">';
                        echo '<img style="width: 13px; height: 13px; margin-right: 2px;" src="' . SKIN_URL . 'sort_paste-above' . $mark . '.gif" alt="' . __('paste selected placeholder before this one') . '" title="' . __('paste selected placeholder before this one') . '" />';
                        echo '</a>';
                    } else {
                        echo '<img style="width: 13px; height: 13px; margin-right: 2px;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" alt="' . __('this is the selected placeholder') . '" title="' . __('this is the selected placeholder') . '" />';
                    }
                } else {
                    echo '<img style="width: 13px; height: 13px; margin-right: 2px;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('please select a placeholder') . '" title="' . __('please select a placeholder') . '" />';
                }

                echo '<br />';

//                $mark = ($_GET['mark']=='s' . $value['id'] ? '2' : '');
                if ($value['id']!=$_SESSION['SID_placeholders_select_id']) {
                    echo '<a href="' . BASE_REL.'_admin/manage_placeholders.php?action=placeholders_select&id='.(int)$value['id'] . '&mark=s' . $value['id'] . '">';
                    echo '<img style="margin: 2px 2px 2px 30px;" src="' . SKIN_URL . 'sort_select' . $mark . '.gif" width="13" height="13" alt="' . __('select this placeholder') . '" title="' . __('select this placeholder') . '" />';
                    echo '</a>';
                } else {
                    echo '<img style="margin: 2px 0 2px 30px;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('this is the selected placeholder') . '" title="' . __('this is the selected placeholder') . '" />';
                }
                echo '<br />';

                if ($value['pos']>=count($placeholder)) {
                    print('<img src="'.SKIN_URL.'sort_empty'.($pholderpos==$value['pos'] && $_GET['action']=='down'?'2':'').'.gif" style="width: 13px; height: 13px; margin-right: 2px;" alt="" >');
                    print('<img src="'.SKIN_URL.'sort_empty'.($_GET['action']=='bottom'?'2':'').'.gif" style="width: 13px; height: 13px; margin-right: 2px;" alt="" >');

                } else {
                    printf('<a href="%s?id=%s&amp;action=down">',
                        htmlspecialchars($_SERVER['PHP_SELF']),
                        htmlspecialchars($value['id'])
                    );
                    print('<img src="'.SKIN_URL.'sort_down'.($pholderpos==$value['pos'] && $_GET['action']=='down'?'2':'').'.gif" style="width: 13px; height: 13px; margin-right: 2px;" alt="'.___('move down').'" title="'.___('move down').'" /></a>');
                    printf('<a href="%s?id=%s&amp;action=bottom">',
                        htmlspecialchars($_SERVER['PHP_SELF']),
                        htmlspecialchars($value['id'])
                    );
                    print('<img src="'.SKIN_URL.'sort_bottom.gif" style="width: 13px; height: 13px; margin-right: 2px;" alt="'.___('move to bottom').'" title="'.___('move to bottom').'" /></a>');

                }

                // paste after
//                $mark = ($_GET['mark']=='pa' . $value['id'] ? '2' : '');
                if (!empty($_SESSION['SID_placeholders_select_id'])) {
                    if ($value['id']!=$_SESSION['SID_placeholders_select_id']) {
                        echo '<a href="' . BASE_REL.'_admin/manage_placeholders.php?action=placeholders_pasteafter&id=' . $value['id'] . '&mark=pa' . $value['id'] . '">';
                        echo '<img style="width: 13px; height: 13px; margin-right: 2px;" src="' . SKIN_URL . 'sort_paste-below' . $mark . '.gif" alt="' . __('paste selected placeholder after this one') . '" title="' . __('paste selected placeholder after this one') . '" />';
                        echo '</a>';
                    } else {
                        echo '<img style="width: 13px; height: 13px; margin-right: 2px;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" alt="' . __('this is the selected placeholder') . '" title="' . __('this is the selected placeholder') . '" />';
                    }
                } else {
                    echo '<img style="width: 13px; height: 13px; margin-right: 2px;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('please select a placeholder') . '" title="' . __('please select a placeholder') . '" />';
                }
            printf('</td>');

            printf('<td>%s</td>', $value['name']); 

            echo '<td>';
            printf ('<a href="'.BASE_REL.'_admin/manage_placeholders.php?action=edit&amp;id='.htmlspecialchars($value['id']).'">'
                .'<img src="'.SKIN_URL.'pic_edit.gif" alt="'.__('edit placeholder settings').'" title="'.__('edit placeholder settings').'" class="pic" alt="" >'
                .'</a>');

            printIcon(
                'manage_placeholders.php?action=create&pos='.(int)$value['pos'].'&templates_id='.(int)$template_id, 
                SKIN_URL.'pic_add_level_before.gif', 
                __('add placeholder before'), 
                true);

            printIcon(
                'manage_placeholders.php?action=create&pos='.((int)$value['pos']+1).'&templates_id='.(int)$template_id, 
                SKIN_URL.'pic_add_level_below.gif', 
                __('add placeholder below'), 
                true);

            if ($phInTemplate[$key]) {
                printIcon(
                    'manage_placeholders.php?action=delete&id='.(int)$value['id'], 
                    SKIN_URL.'pic_del.gif', 
                    __('please remove the placeholder from the article-template first'),
                    false);
            } else {
                printIcon(
                    'manage_placeholders.php?action=delete&id='.(int)$value['id'], 
                    SKIN_URL.'pic_del.gif', 
                    __('delete placeholder'), 
                    true);
            }

            echo '</td>';
            printf('<td>%s</td>', $value['type']);
            print('<td>');
            $options = '';
            if (trim($value['label'])!='') $options .= htmlspecialchars($value['label']);
            if ($options!='') print($options.'<br />');

            print(' </td>');
            print('</tr>');
        }
        print('</tbody></table>');
        require(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'edit': // {{{
        include(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            __('Work on placeholder settings'),
            sprintf(__('In this view you edit the settings of the placeholder %s.'), '<em>'.htmlspecialchars($placeholder['name']).'</em>'),
            'templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings'
        );

        print('<form action="'.BASE_REL.'_admin/manage_placeholders.php" method="POST">');
        print('<table class="colored" style="width: 100%;">');
        print('<input name="id" type="hidden" value="'.htmlspecialchars($placeholder['id']).'"></td></tr>');
        print('<input name="action" type="hidden" value="save"></td></tr>');

        print('<thead><tr><th colspan="2"><span>'.___('Placeholder properties').'</span></th></tr></thead>');
        print('<tbody>');

        print('<tr><td class="leftrow">'.__('Name:').'</td><td class="rightrow">');
        print(htmlspecialchars($placeholder['name']).help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-name').'</td></tr>');

        print('<tr><td>'.___('Type:').'</td><td>');
        print(htmlspecialchars($placeholder['type']).help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-type').'</td></tr>');

        switch ($placeholder['type']) {
        case 'divider':
            print('<tr><td>'.__('Description:').'</td><td>');
            print('<input name="placeholder[label]" type="text" value="'.htmlspecialchars($placeholder['label']).'" class="inputwidth">'.help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-description').'</td></tr>');
            // no break!
        case 'submitbutton':
            break;
        case 'text': 
			// {{{ mod_text
			if ($placeholder['formtype']=='short') $placeholder['short']=1; 
			if (array_key_exists('mod_text',$activeModules)) { include(CPO_BASEDIR.$activeModules['mod_text']['directory'].'/includes/manage_placeholder.inc.php'); break; } 
			// }}}
            print('<tr><td>'.__('Description:').'</td><td>');
            print('<input name="placeholder[label]" type="text" value="'.htmlspecialchars($placeholder['label']).'" class="inputwidth">'.help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-description').'</td></tr>');
            
            print('<tr><td>'.___('Input method:').'</td><td>');
            echo '<select name="placeholder[inputmethod]" class="inputwidth">';
            echo '<option value="textarea" '.($placeholder['inputmethod']=='textarea' ? ' selected' : '').'>'.___('Multiple lines').'</option>';
            echo '<option value="text"     '.($placeholder['inputmethod']=='text'  || $placeholder['short']==1 ? ' selected' : '').'>'.___('Single line').'</option>'; // 'short' is DEPRECATED
            echo '<option value="select"   '.($placeholder['inputmethod']=='select'   ? ' selected' : '').'>'.___('Select-box').'</option>';
            echo '<option value="radio"    '.($placeholder['inputmethod']=='radio'    ? ' selected' : '').'>'.___('Radio-Buttons').'</option>';
            echo '<option value="checkbox" '.($placeholder['inputmethod']=='checkbox' ? ' selected' : '').'>'.___('Checkboxes').'</option>';
            echo '<option value="none"     '.($placeholder['inputmethod']=='none'     ? ' selected' : '').'>'.___("Don't query, use presetting").'</option>';
            echo '</select>';
            print(help('').'</td></tr>');

            print('<tr><td>' . ___('Maximum length:').'</td><td>');
            print('<input name="placeholder[maximumlength]" type="text" value="'.htmlspecialchars($placeholder['maximumlength']).'" class="inputwidth">');
            print(help('').'</td></tr>');
            
            // if the field starts with a newline in any form, add another one
            // otherwise the textarea will ignore the starting newline
            if (preg_match('/^(\r\n|\n|\r)(.*)/', $placeholder['presetting'], $matches)) {
                $placeholder['presetting'] = $matches[1] . $placeholder['presetting'];
            }
            print('<tr><td>'.___('Presetting:').'</td><td>');
            print('<textarea  name="placeholder[presetting]" class="inputwidth">'.htmlspecialchars($placeholder['presetting']).'</textarea>');
            print(help('').'</td></tr>');
            break;
        case 'url': 
            print('<tr><td>'.__('Description:').'</td><td>');
            print('<input name="placeholder[label]" type="text" value="'.htmlspecialchars($placeholder['label']).'" class="inputwidth">'.help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-description').'</td></tr>');
            
            print('<tr><td>'.__('Link type:').'</td><td>');
            print('<select class="select" name="placeholder[linktype]" size="1">');
                print('<option value="0" '.($placeholder['linktype']=='0' ? 'selected' : '').'>'.__('URL can be entered').'</option>');
                print('<option value="1" '.($placeholder['linktype']=='1' ? 'selected' : '').'>'.__('URL to article page').'</option>');
                print('<option value="3" '.($placeholder['linktype']=='3' ? 'selected' : '').'>'.__('URL to rubric page').'</option>');
                print('<option value="2" '.($placeholder['linktype']=='2' ? 'selected' : '').'>'.__('URL that goes back (Javascript)').'</option>');
            print('</select>');
            print(help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-urltype').'</td></tr>');

            print('<tr><td>'.__('Don\'t query:').'</td><td>');
            print('<input name="placeholder[noquery]" class="checkbox" type="checkbox" value="1" '.($placeholder['noquery']=='1' ? 'checked' : '').'>');
            print(help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-dontask').'</td></tr>');
            break;
		// file_filter {{{ 
		case 'file': 
		case 'image': 
			print('<tr><td>'.__('Description:').'</td><td>'); 
			print('<input name="placeholder[label]" type="text" value="'.htmlspecialchars($placeholder['label']).'" class="inputwidth">'.help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-description').'</td></tr>');
			if (array_key_exists('mod_text',$activeModules)) { 
				print('<tr><td>'.__('Related to:').'</td><td>'); 
				print('<input name="placeholder[relation]" type="text" value="'.htmlspecialchars($placeholder['relation']).'"> ');
				print('&nbsp; &nbsp;'.__('Pattern:').' '); 
				print('<input name="placeholder[pattern]" type="text" value="'.htmlspecialchars($placeholder['pattern']).'"></td></tr>');
			}
			break; 
		// }}} 
        default:
            print('<tr><td>'.__('Description:').'</td><td>');
            print('<input name="placeholder[label]" type="text" value="'.htmlspecialchars($placeholder['label']).'" class="inputwidth">'.help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-description').'</td></tr>');
            
            print('<tr><td>'.__('Don\'t query:').'</td><td>');
            print('<input name="placeholder[noquery]" class="checkbox" type="checkbox" value="1" '.($placeholder['noquery']=='1' ? 'checked' : '').'>');
            print(help('templates-workonarticletemplates.html#templates-workonarticletemplates-editplaceholder-settings-dontask').'</td></tr>');
            break;
        }

		// {{{ mod_text
		if (array_key_exists('mod_text',$activeModules)) include(CPO_BASEDIR.$activeModules['mod_text']['directory'].'/includes/checkhidden.inc.php');
		// }}}

		print('<tr><td>&nbsp;</td><td>');
        print('<input name="submit" class="button" type="submit" value="'.__('save').'"></td></tr>');

        print('</tbody></table>');
        print('</form>');

        require(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'create': // {{{
        include(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            __('Create placeholder'),
            sprintf(__('In this view you create a new placeholder for the article-template %s.'), 
                '<em>'.htmlspecialchars($templatename).'</em>'),
            ''
        );

        include(CPO_BASEDIR.'_include/message.php');

        print('<form action="'.BASE_REL.'_admin/manage_placeholders.php" method="POST">');
        print('<table class="colored" style="width: 100%;">');
        print('<input name="pos" type="hidden" value="'.htmlspecialchars($_REQUEST['pos']).'"></td></tr>');
        print('<input name="templates_id" type="hidden" value="'.htmlspecialchars($_REQUEST['templates_id']).'"></td></tr>');
        print('<input name="action" type="hidden" value="createsave"></td></tr>');

        print('<thead><tr><th colspan="2"><span>'.___('Placeholder properties').'</span></th></tr></thead>');
        print('<tbody>');

        print('<tr><td class="leftrow">'.__('Name:').'</td><td class="rightrow">');
        print('<input name="name" type="text" value="'.htmlspecialchars($_REQUEST['name']).'" class="inputwidth">'.help('').'</td></tr>');


        print('<tr><td>'.___('Type:').'</td><td>');
        echo '<select name="type">';
        foreach ($typeNames as $k=>$v) {
            if ($v=='') continue;
            if ($v=='value') continue;
            echo '<option value="'.htmlspecialchars($k).'" '.($_REQUEST['type']==$k ? 'selected' : '').'>'.htmlspecialchars($v).'</option>';
        }
        echo '</select>';
        //print('<input name="type" type="text" value="'.htmlspecialchars($_REQUEST['type']).'" class="inputwidth">'.help('').'</td></tr>');

        print('<tr><td>&nbsp;</td><td>');
        print('<input name="submit" class="button" type="submit" value="'.__('save').'"></td></tr>');

        print('</tbody></table>');
        print('</form>');

        require(CPO_BASEDIR.'_include/footer.php');

        break; // }}}
    case 'reallydelete': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            ___('Delete placeholder'),
            sprintf(___('In this view you can delete the placeholder %s.'),
                '<em>'.htmlspecialchars($fieldname).'</em>'
            ),
            '' // FIXME
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to delete the placeholder %s?'), 
            '<em>'.htmlspecialchars($fieldname).'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= '<input type="hidden" name="action" value="reallydelete">';
        $message .= '<input type="hidden" name="id" value="'.htmlspecialchars($_REQUEST['id']).'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');

        break; // }}}
    }
}
?>
