<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */

// pre_modded for mod_text by M. Rsel www.conpresso4.de

if (!defined('CPO')) exit;

$length_script = 
     '<script type="text/javascript"><!--' ."\n" .
     'function textCounter(field, countfield, maxlimit) { ' ."\n" .
     'if (field.value.length > maxlimit) ' ."\n" .
     'field.value = field.value.substring(0, maxlimit); ' ."\n" .
     'else ' ."\n" .
     'countfield.value = maxlimit - field.value.length; ' ."\n" .
     '}' ."\n".
     '// --></script>' . "\n";

if (!nametype($key, $name, $type)) continue;
$keymd5 = md5($key);

// If this placeholder is marked to not be queried, skip it
if (isset($value['noquery']) && (bool)($value['noquery'])) return;

// {{{ mod_text
if (array_key_exists('mod_text',$activeModules)) include(CPO_BASEDIR.$activeModules['mod_text']['directory'].'/includes/hiddencode.inc.php');
// }}}

if (!is_array($content)) $content = array();
switch ($type) {
case 'divider':
    echo '<tr '.$markashidden.' class=""><td class="leftrow" colspan="2" style="height: 3em; border-bottom: 1px dotted;">';
    
    if (!empty($value['label'])) {
        printf('<strong style="position: relative; top: 2.1em; left: 2px; padding: 0 0.2em;">%s</strong>',
            htmlspecialchars($value['label'])
        );
    }
    echo '<br /></td></tr>';
    echo '<tr '.$markashidden.' class="same"><td class="leftrow" colspan="2" style="height: 3em;"><br /></td></tr>';
    break;
case 'submitbutton':
    echo '<tr '.$markashidden.'><td class="leftrow">&nbsp;</td><td class="rightrow">';
    echo '<input type="submit" class="button" value="' . ___('save article') . '" />';
    if ($_SESSION['SID_stufe4']==1 && $cpoSystem['release']) {
        print('<input name="article_free" type="submit" class="button" value="' . ___('save and release article') . '">');
    }
    echo '</td></tr>';
    break;
case 'file': // {{{
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty values exist for a key without content.
    if (!array_key_exists($key, $content)) $content[$key] = array('id'=>'', 'file_id'=>'');

    printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
        htmlspecialchars($name));
    // print label
    if (isset($value['label']) && trim($value['label'])!='') {
        printf('%s<br /><br />', $value['label']);
    }

    // print file selection box
    $query = "SELECT id, beschreibung, datei "
            ."FROM ".CPO_DATA." "
            ."WHERE (rubric_id='".$_SESSION['SID_rubric_id']."' "
            ."OR rubric_id='-1' ) "
            ."AND format='1' "
			.((isset($value['relation']) && isset($value['pattern']) && trim($value['relation'])!='') ? "AND datei LIKE '".str_replace('###',$content[trim($value['relation']).' (text)']['text'],$value['pattern'])."' " : '') // file_filter
            ."ORDER BY datei";
    DEBUG(1, 'Fetching files for this rubric.<br /><br />'.$query, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query); 

    printf('<select name="content[%s][file_id]" size="1" class="inputwidth iframe">', 
        htmlspecialchars($key));
    print('<option value="">'.___('no file').'</option>');
    print('<option value="">------</option>');

    while($db_2->next_record()) {
        $id             = $db_2->v('id');
        $k_datei        = $db_2->v('datei');
        $k_beschreibung = '['.substr($db_2->v('beschreibung'), 0, 77-strlen($k_datei)).']';
        if ($k_beschreibung=='[]') $k_beschreibung = '';

        $_selected = '';
        if ($content[$key]['file_id']==$id) $_selected = 'selected';

        printf('<option value="%s" %s>%s %s</option>',
            $id,
            $_selected,
            $k_datei,
            $k_beschreibung
        );
    }
    print('</select>');
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-files'));
    print('</td></tr>');
    break; // }}}
case 'image': // {{{
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty values exist for a key without content.
    if (!array_key_exists($key, $content)) {
        $content[$key] = array('id'=>'', 'image_id'=>'');
    }

    printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
        $name);
    if (isset($value['label']) && trim($value['label'])!='') {
        printf('%s<br /><br />', $value['label']);
    }

    $query = "SELECT id, beschreibung, datei FROM ".CPO_DATA." "
            ."WHERE (rubric_id='".$_SESSION['SID_rubric_id']."' "
            ."OR rubric_id='-1') " 
            ."AND format='2' "
			.((isset($value['relation']) && isset($value['pattern']) && trim($value['relation'])!='') ? "AND datei LIKE '".str_replace('###',$content[trim($value['relation']).' (text)']['text'],$value['pattern'])."' " : '') // file_filter
            ."ORDER BY datei"; 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query); 

    printf('<select name="content[%s][image_id]" size="1" class="inputwidth">', htmlspecialchars($key));
    print('<option value="">'.___('no image').'</option><option value="">------</option>');
    while($db_2->next_record()):
        $k_beschreibung = '['.substr($db_2->v('beschreibung'), 0, 76-strlen($db_2->v('datei'))).']';
        if ($k_beschreibung=='[]') $k_beschreibung = '';

        $_selected = '';
        if ($content[$key]['image_id']==$db_2->v('id')) {
            $_selected = 'selected';
        }

        printf('<option value="%s" %s>%s %s</option>',
            $db_2->v('id'),
            $_selected,
            $db_2->v('datei'),
            $k_beschreibung
        );
    endwhile;
    print('</select>');
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-images'));
    print('</td></tr>');
    break; // }}}
case 'text': // {{{
	// {{{ mod_text
	if ($value['formtype']=='short') $value['inputmethod'] = 'text';
	if (array_key_exists('mod_text',$activeModules)) { include(CPO_BASEDIR.$activeModules['mod_text']['directory'].'/includes/form_fields.inc.php'); break; } 
	// }}}
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty values exist for a key without content.
    if (!array_key_exists($key, $content)) {
        $content[$key] = array('id'=>'', 'text'=>'');
    }

    if ($value['short']==1) $value['inputmethod'] = 'text';

    switch ($value['inputmethod']) {
    case 'text': // {{{
        printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
            htmlspecialchars($name));
        if (isset($value['label']) && trim($value['label'])!='') {
            printf('%s<br /><br />', $value['label']);
        }

        if (empty($value['maximumlength'])) {
            printf('<input type="text" name="content[%s][text]" value="%s" size="80" class="inputwidth" />', 
                htmlspecialchars($key),
                htmlspecialchars($content[$key]['text'])
            );
            print(help('articles-createarticle.html#articles-createarticle-articlecontent-texts-shorttext'));
        } else {
            echo $length_script; $length_script = '';
            printf('<input type="text" name="content[%1$s][text]" id="text%2$s" value="%4$s" size="80" class="inputwidth" ' .
                   'onKeyDown="textCounter(this.form.text%2$s, this.form.remLen%2$s, %3$s);" ' .
                   'onKeyUp="  textCounter(this.form.text%2$s, this.form.remLen%2$s, %3$s);" />', 
                htmlspecialchars($key),
                $keymd5,
                $value['maximumlength'],
                htmlspecialchars($content[$key]['text'])
            );
            print(help('articles-createarticle.html#articles-createarticle-articlecontent-texts-shorttext'));
            printf('<br />' . ___('%s characters left'),
                '<input readonly type="text" name="remLen' . $keymd5 . '" size="4" maxlength="4" value="' . 
                ($value['maximumlength'] - strlen($content[$key]['text'])) . '" />');
        }
        
        print('</td></tr>');
        break; // }}}
    case 'select': // {{{
        $_lines = str_replace(array("\r\n", "\r", "\n"), "\n", $value['presetting']);
        $_lines = explode("\n", $_lines);

        if (count($_lines)==0) break;

        printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
            htmlspecialchars($name));
        if (isset($value['label']) && trim($value['label'])!='') {
            printf('%s<br /><br />', $value['label']);
        }

        echo '<select name="content['.htmlspecialchars($key).'][text]" class="inputwidth">';
        $i = 0;
        foreach ($_lines as $line) {
            $i++;
            $line   = trim($line);

            $_name  = $line;
            $_value = $line;

            // check if it is "name = value"?
            if (1==preg_match('/(.*?)\s*[^\\\]=\s*(.*)/', $line, $matches)) {
                $_value = str_replace('\=', '=', $matches[1]);
                $_name  = str_replace('\=', '=', $matches[2]);
            }
            // the first one is default
            if ($i==1 && $content[$key]['text']=='') {
                $content[$key]['text'] = $_value;
            }

            echo '<option '
                .'value="'.htmlspecialchars($_value).'" '
                .($content[$key]['text']==$_value ? 'selected="selected">' : '>')
                .htmlspecialchars($_name).'</option>';
        } 
        echo '</select>';
        print(help(''));
        print('</td></tr>');
        break; // }}}
    case 'radio': // {{{
        $_lines = str_replace(array("\r\n", "\r", "\n"), "\n", $value['presetting']);
        $_lines = explode("\n", $_lines);

        if (count($_lines)==0) break;

        printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
            htmlspecialchars($name));
        if (isset($value['label']) && trim($value['label'])!='') {
            printf('%s<br /><br />', $value['label']);
        }

        $i = 0;
        foreach ($_lines as $line) {
            $i++;
            $line = trim($line);

            $_name  = $line;
            $_value = $line;

            // check if it is "name = value"?
            if (1==preg_match('/(.*?)\s*[^\\\]=\s*(.*)/', $line, $matches)) {
                $_value = str_replace('\=', '=', $matches[1]);
                $_name  = str_replace('\=', '=', $matches[2]);
            }
            // the first one is always default with radiobuttons:
            if ($i==1 && $content[$key]['text']=='') {
                $content[$key]['text'] = $_value;
            }

            echo '<input type="radio" name="content['.htmlspecialchars($key).'][text]" '
                .'id="'.md5($_value.$_name).'" '
                .'value="'.htmlspecialchars($_value).'" '
                .($content[$key]['text']==$_value ? 'checked="checked" />' : '/>')
                .'<label for="'.md5($_value.$_name).'">'.htmlspecialchars($_name).'</label>';
            if ($i==1) print(help(''));
            echo '<br />';
        } 
        print('</td></tr>');
        break; // }}}
    case 'checkbox': // {{{
        $_lines = str_replace(array("\r\n", "\r", "\n"), "\n", $value['presetting']);
        $_lines = explode("\n", $_lines);

        if (count($_lines)==0) break;

        printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
            htmlspecialchars($name));
        if (isset($value['label']) && trim($value['label'])!='') {
            printf('%s<br /><br />', $value['label']);
        }

        $line = trim($_lines[0]); // the checkbox only allows the first line to be chosen
        $_name  = $line;
        $_value = $line;

        // check if it is "name = value"?
        if (1==preg_match('/(.*?)\s*[^\\\]=\s*(.*)/', $line, $matches)) {
            $_value = str_replace('\=', '=', $matches[1]);
            $_name  = str_replace('\=', '=', $matches[2]);
        }

        echo '<input type="checkbox" name="content['.htmlspecialchars($key).'][text]" '
            .'id="'.md5($_value.$_name).'" '
            .'value="'.htmlspecialchars($_value).'" '
            .($content[$key]['text']==$_value ? 'checked="checked" />' : '/>')
            .'<label for="'.md5($_value.$_name).'">'.htmlspecialchars($_name).'</label>';
        print(help(''));

        print('</td></tr>');
        break; // }}}
    case 'none': // {{{
        printf('<input type="hidden" name="content[%s][text]" value="%s" />', 
            htmlspecialchars($key),
            htmlspecialchars($value['presetting'])
        );
        print('</td></tr>');
        break; // }}}
    case 'textarea': // default // {{{
    default:
        printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
            htmlspecialchars($name));
        if (isset($value['label']) && trim($value['label'])!='') {
            printf('%s<br /><br />', $value['label']);
        }

        if (empty($value['maximumlength'])) {
            printf('<textarea name="content[%1$s][text]" id="text%2$s" cols="80" rows="15" class="inputwidth">%3$s</textarea>', 
                htmlspecialchars($key),
                $keymd5,
                htmlspecialchars($content[$key]['text'])
            );
            print(help('articles-createarticle.html#articles-createarticle-articlecontent-texts-text'));
            printf('<br /><a href="#" onClick="javascript:a = document.getElementById(\'text%1$s\'); if (a.rows>5) a.rows=a.rows-5; return false;">' .
                   '<img src="' . SKIN_URL . 'decrease.gif" width="20" height="18" align="absmiddle" alt="%2$s" />%2$s</a>', 
                $keymd5,
                ___('-decrease height')
            );
            echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
            printf('<a href="#" onClick="javascript:a = document.getElementById(\'text%1$s\'); a.rows=a.rows+5; return false;">' .
                   '<img src="' . SKIN_URL . 'enlarge.gif" width="20" height="18" align="absmiddle" alt="%2$s" />%2$s</a>', 
                $keymd5,
                ___('-increase height')
            );
                    } else {
            echo $length_script; $length_script = '';
            printf('<textarea name="content[%1$s][text]" id="text%2$s" cols="80" rows="%3$s" class="inputwidth" ' .
                   'onKeyDown="textCounter(this.form.text%2$s, this.form.remLen%2$s, %4$s);" ' .
                   'onKeyUp="  textCounter(this.form.text%2$s, this.form.remLen%2$s, %4$s);">%5$s</textarea>', 
                htmlspecialchars($key),
                $keymd5,
                ceil($value['maximumlength']/80)+1,
                $value['maximumlength'],
                htmlspecialchars($content[$key]['text'])
            );
            print(help('articles-createarticle.html#articles-createarticle-articlecontent-texts-text'));
            printf('<br />' . ___('%s characters left'),
                '<input readonly type="text" name="remLen' . $keymd5 . '" size="4" maxlength="4" value="' . 
                ($value['maximumlength'] - strlen($content[$key]['text'])) . '" />');
        }
        print('</td></tr>');
        break; // }}}
    }
    break; // }}}
case 'html': // {{{
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty value exist for a key without content.
    if (!array_key_exists($key, $content)) { 
        $content[$key] = array('id'=>'', 'html'=>'');
    }

    printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
        htmlspecialchars($name));
    if (isset($value['label']) && trim($value['label'])!='') {
        printf('%s<br /><br />', $value['label']);
    }

    if (!RTECheck()) {
        printf('<textarea name="content[%s][html]" cols="80" rows="15" class="inputwidth">%s</textarea>', 
            htmlspecialchars($key),
            htmlspecialchars($content[$key]['html'])
        );
        echo help(''); // helpme
        echo '<br />';
        printf(___('Please note that your browser (%s) is not capable of rich-text-editing, so you can only edit the HTML-Code in the textarea above.'),
            '<em>'.htmlspecialchars($_SERVER['HTTP_USER_AGENT']).'</em>'
        );
        print('</td></tr>');
        break;
    } 
    $html_texts[] = $keymd5; // this allows to add a javascript which puts all iframes into the hidden field later

    printf('<iframe id="iframe_%1$s" name="%1$s" frameborder="0" height="200" class="iframe inputwidth"></iframe>',
        $keymd5
    );
    printf('<input type="hidden" name="content[%s][html]" id="feld_%s" value="">', 
        htmlspecialchars($key), 
        $keymd5
    );
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-texts-html'));

    $text_value = $content[$key]['html'];
    // to avoid problems with the document.writeln below
    $text_value = preg_replace ('/(\015\012|\015|\012)/', ' ', $text_value);
    $text_value = addslashes($text_value);
    $text_value = str_replace('</', '<\/', $text_value);
    ?>
    <script type="text/javascript">
        iframe = document.getElementById('iframe_<?php echo $keymd5; ?>').contentWindow.document;
        iframe.open();
        iframe.write('<html><head>');
        <?php 
        if (!empty($cpoSystem['CSSURL'])) {
            echo 'iframe.write(\'<link rel="stylesheet" type="text/css" href="'.$cpoSystem['CSSURL'].'">\');';
        }
        ?>
        iframe.write('</head><body><?php echo $text_value; ?></body></html>');
        iframe.close();
    </script>

    <?php
    printf('<br /><a href="#text_%1$s" onClick="editorwindow = window.open(\''.BASE_REL.'_editor/editor.php?saveto=iframe_%1$s&%2s\', \'editor_popup\', \'dependent=yes, width=750, height=580, resizable=yes, status=yes\');">'
        .'<img src="'.SKIN_URL.'edit.gif" width="20" height="18" align="absmiddle" alt="%3$s" />%3$s'
        .'</a>',
        $keymd5,
        SID,
        ___('-edit')
    );
    echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
    printf('<a href="#text_%1$s" onClick="if (confirm(\'%4$s\')) {iframe = document.getElementById(\'iframe_%1$s\').contentWindow; iframe.document.write(); iframe.document.close();}">'
        .'<img src="' . SKIN_URL . 'clear.gif" width="20" height="18" align="absmiddle" alt="%3$s" />%3$s'
        .'</a>',
        $keymd5,
        SID,
        ___('-clear'),
        ___('Are you sure you want to clear this HTML field?')
    );
    echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
    printf('<a href="#" onClick="a = document.getElementById(\'iframe_%1$s\'); if (a.offsetHeight>60) a.style.height = a.offsetHeight-50 + \'px\'; return false;">' .
           '<img src="' . SKIN_URL . 'decrease.gif" width="20" height="18" align="absmiddle" alt="%2$s" />%2$s</a>', 
        $keymd5,
        ___('-decrease height')
    );
    echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
    printf('<a href="#" onClick="a = document.getElementById(\'iframe_%1$s\'); a.style.height = a.offsetHeight+50 + \'px\'; return false">' .
           '<img src="' . SKIN_URL . 'enlarge.gif" width="20" height="18" align="absmiddle" alt="%2$s" />%2$s</a>', 
        $keymd5,
        ___('-increase height')
    );
    print('</td></tr>');
    break; // }}}
case 'url': // {{{
    // remove key from temporary content array so that only not used content is left
    unset($_content[$key]); 

    // make sure an empty value exist for a key without content.
    if (!array_key_exists($key, $content)) {
        $content[$key] = array('id'=>'', 'url'=>'', 'urltext'=>'', 'urltarget'=>'');
    }

    printf('<tr '.$markashidden.'><td class="leftrow">%s:</td><td class="rightrow">',
        htmlspecialchars($name));
    if (isset($value['label']) && trim($value['label'])!='') printf('%s<br />', $value['label']);

    if ($value['linktype']!=0) {
        printf('<input type="hidden" name="content[%s][url]" value="">', 
            htmlspecialchars($key)
        );
    } else {
        printf('</td></tr><tr '.$markashidden.' class="same"><td class="leftrow">%s</td><td class="rightrow">', ___('URL:'));
        printf('<input type="text" name="content[%s][url]" value="%s" id="%s" class="inputwidth">', 
            htmlspecialchars($key),
            htmlspecialchars($content[$key]['url']),
            htmlspecialchars(md5($key))
        );
        print(help('articles-createarticle.html#articles-createarticle-articlecontent-url-url'));

        echo '<br />';
        echo ' <select class="inputwidth" id="edit_a_rubric" onChange="getElementById(\''.htmlspecialchars(md5($key)).'\').value = this.value; this.selectedIndex=0;">';
        echo '<option value="">'.__('Generate a link to a rubric:').'</option>';
        $db = new DB;
        $query = "SELECT id, name, directory "
                ."FROM ".CPO_RUBRIC." "
                .'ORDER BY name';
        $db->query($query);
        while($db->next_record()) {
            printf('<option value="%s">%s</option>',
                htmlspecialchars(BASE_ABS.$db->v('directory').'/index.php?rubric='.urlencode($db->v('name'))),
                htmlspecialchars($db->v('name'))
            );
        }
        echo '</select>';

    }


    printf('</td></tr><tr '.$markashidden.' class="same"><td class="leftrow">%s</td><td class="rightrow">', ___('Link text:'));
    printf('<input type="text" name="content[%s][urltext]" value="%s" class="inputwidth">', 
        htmlspecialchars($key),
        htmlspecialchars($content[$key]['urltext'])
    );
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-url-linktext'));

    printf('</td></tr><tr '.$markashidden.' class="same"><td class="leftrow">%s</td><td class="rightrow">', ___('Target:'));
    $targets = explode(' ', $cpoSystem['targets']);
    printf('<select name="content[%s][urltarget]" size="1" class="inputwidth">', htmlspecialchars($key));
    print('<option value="">' . ___('no target') . '</option><option value="">------</option>');
    foreach($targets as $v) {
        printf('<option value="%1$s" %2$s>%1$s</option>',
            htmlspecialchars($v),
            trim($content[$key]['urltarget'])==trim($v) ? 'selected' : ''
        );
    }
    print('</select>');
    print(help('articles-createarticle.html#articles-createarticle-articlecontent-url-target'));
    print('</td></tr>');
    break; // }}}
case 'value': // {{{
    break; // }}}
default: // {{{
    printf('<!-- Not defined typeTag %s (%s)-->', htmlspecialchars($type), htmlspecialchars($name));
    break; // }}}
}
print($divider);
?>
